// material class
// -Kyoung Shin Park (2014 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __MATERIAL_H__
#define __MATERIAL_H__

#include "moglclass.h"
#include "shaders.h"

namespace moglclass
{

class Material
{
public:
    Material(void);
    Material(glm::vec4& ambientAndDiffuse);
    Material(glm::vec4& ambientAndDiffuse, glm::vec4& specular, float shininess);
    Material(glm::vec4& ambient, glm::vec4& diffuse, glm::vec4& specular, float shininess);
	void setUniform(Program* p, std::string materialName);
    
    void setAmbient(glm::vec4& ambient);
    void setDiffuse(glm::vec4& diffuse);
    void setAmbientAndDiffuse(glm::vec4& ambientAndDiffuse);
    void setSpecular(glm::vec4& specular);
    void setEmission(glm::vec4& emission);
    void setShininess(float shininess);

    glm::vec4 Ambient, Diffuse, Specular, Emission;
    float Shininess;
};

} // namespace

#endif
